<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [conan-discord](./conan-discord.md)

## conan-discord package

## Functions

|  Function | Description |
|  --- | --- |
|  [authorName(author)](./conan-discord.authorname.md) | Friendly name for an Author. |
|  [checkAuthor(author, admins, roles)](./conan-discord.checkauthor.md) | Check if an author is allowed to execute a command. |
|  [commandName(command, prefix)](./conan-discord.commandname.md) | Wrapper for append with a default prefix. |
|  [discordConnect(botContext, commands, clientCtor)](./conan-discord.discordconnect.md) | <p>Connect to a Discord server using a bot token.</p><p>Requires [ParsedArgs.discordToken](./conan-discord.parsedargs.discordtoken.md) to be set in <code>args</code>.</p> |
|  [matchCommands(msg, commands, prefix)](./conan-discord.matchcommands.md) | Match command names against a message body. |
|  [parseArgs(argv)](./conan-discord.parseargs.md) | Parse CLI options and environment variables. |
|  [parseBody(msg, command, prefix, options, positionals)](./conan-discord.parsebody.md) | Remove the command name from a message, parse any CLI args, and return them with the remainder of the message body. |
|  [rconConnect(args, logger)](./conan-discord.rconconnect.md) | Create (and monkey-patch) an RCON client. |
|  [readlineConnect(botContext, commands, readlineFactory)](./conan-discord.readlineconnect.md) | <p>Start the readline bot interface.</p><p>This reads input from stdin and send replies through the logging system, and is meant for interactive debugging.</p> |
|  [removeCommandName(msg, command, prefix)](./conan-discord.removecommandname.md) | Parse and remove the command name from a message body. |
|  [sendWithRetry(client, command, logger, retries)](./conan-discord.sendwithretry.md) | Send an RCON command and attempt to reconnect and retry if it fails. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [Author](./conan-discord.author.md) | Message author. |
|  [Bot](./conan-discord.bot.md) | Necessary methods for a bot. |
|  [BotContext](./conan-discord.botcontext.md) | Context passed to a [Bot](./conan-discord.bot.md) when it is created. |
|  [Command](./conan-discord.command.md) | Bot command with optional authn/authz. |
|  [CommandContext](./conan-discord.commandcontext.md) | Context passed to [Command.run](./conan-discord.command.run.md) when invoked. |
|  [DiscordBot](./conan-discord.discordbot.md) | Discord-only methods. |
|  [Message](./conan-discord.message.md) | Text message with ability to reply. |
|  [ParsedArgs](./conan-discord.parsedargs.md) | CLI options. |
|  [RconClient](./conan-discord.rconclient.md) | RCON client methods. |
|  [ReadlineBot](./conan-discord.readlinebot.md) | Readline-only methods. |
|  [Roles](./conan-discord.roles.md) | Roles who should be able to execute a command. |

## Variables

|  Variable | Description |
|  --- | --- |
|  [LOCAL\_DISCRIMINATOR](./conan-discord.local_discriminator.md) | Discriminator for local authors. |
|  [ROLE\_ADMIN\_ONLY](./conan-discord.role_admin_only.md) | Role for admin-only commands. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [BodyOptions](./conan-discord.bodyoptions.md) | Transform a type into its yargs options. |
|  [BotCtor](./conan-discord.botctor.md) | Constructor for a Bot. |
|  [StringsOnly](./conan-discord.stringsonly.md) | Filter out string types. |

