## API Report File for "conan-discord"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="node" />

import { Client } from 'discord.js';
import { createInterface } from 'node:readline/promises';
import { Logger } from 'noicejs';
import { PositionalOptions } from 'yargs';
import yargs from 'yargs';

// @public
export interface Author {
    // (undocumented)
    discriminator: string;
    // (undocumented)
    username: string;
}

// @public
export function authorName(author: Author): string;

// @public
export type BodyOptions<T> = {
    [key in StringsOnly<keyof T>]: yargs.Options;
};

// @public
export interface Bot {
    // (undocumented)
    commands: ReadonlyArray<Command>;
    // (undocumented)
    connect(): Promise<boolean>;
    // (undocumented)
    destroy(): void;
    // (undocumented)
    getUser(ident: string): Promise<Author | undefined>;
}

// @public
export interface BotContext {
    // (undocumented)
    args: ParsedArgs;
    // Warning: (ae-forgotten-export) The symbol "DataLayer" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    data: DataLayer;
    // (undocumented)
    logger: Logger;
    // (undocumented)
    rcon: RconClient;
}

// @public
export type BotCtor = (context: BotContext, commands: ReadonlyArray<Command>) => Promise<Bot>;

// @public
export function checkAuthor(author: Author, admins: Array<string>, roles: Roles): boolean;

// @public
export interface Command {
    // (undocumented)
    auth?: (author: Author, context: CommandContext) => Promise<boolean>;
    // (undocumented)
    desc: string;
    // (undocumented)
    name: string;
    // (undocumented)
    run: (msg: Message, context: CommandContext) => Promise<void>;
}

// @public
export interface CommandContext {
    // (undocumented)
    args: ParsedArgs;
    // (undocumented)
    bot: Bot;
    // (undocumented)
    command: Command;
    // (undocumented)
    data: DataLayer;
    // (undocumented)
    logger: Logger;
    // (undocumented)
    rcon: RconClient;
}

// @public
export function commandName(command: Command, prefix: string): string;

// @public
export interface DiscordBot extends Bot {
    // (undocumented)
    destroy(): void;
}

// @public
export function discordConnect(botContext: BotContext, commands: ReadonlyArray<Command>, clientCtor?: typeof Client): Promise<DiscordBot>;

// @public
export const LOCAL_DISCRIMINATOR = "local";

// @public
export function matchCommands(msg: string, commands: ReadonlyArray<Command>, prefix: string): ReadonlyArray<Command>;

// @public
export interface Message {
    // (undocumented)
    author: Author;
    // (undocumented)
    content: string;
    // (undocumented)
    reply(msg: string): Promise<Message>;
}

// @public
export function parseArgs(argv: Array<string>): Promise<ParsedArgs>;

// @public
export function parseBody<ArgT, OptionT extends BodyOptions<ArgT> = BodyOptions<ArgT>, ArgVT = ArgT & {
    _: Array<string>;
}>(msg: string, command: Command, prefix: string, options: OptionT, positionals?: Array<[StringsOnly<keyof ArgT>, PositionalOptions]>): Promise<[string, ArgVT]>;

// @public
export interface ParsedArgs {
    // (undocumented)
    bots: Array<string>;
    // (undocumented)
    commandAdmins: Array<string>;
    // (undocumented)
    commandPrefix: string;
    // (undocumented)
    data: string;
    // (undocumented)
    discordToken: string;
    // (undocumented)
    rconHost: string;
    // (undocumented)
    rconPassword: string;
    // (undocumented)
    rconPort: number;
    // (undocumented)
    sqliteDatabase: string;
}

// @public
export interface RconClient {
    // (undocumented)
    connect(): Promise<this>;
    // (undocumented)
    end(): void;
    // (undocumented)
    send(command: string): Promise<string>;
}

// @public
export function rconConnect(args: ParsedArgs, logger: Logger): Promise<RconClient>;

// @public
export interface ReadlineBot extends Bot {
    // (undocumented)
    destroy(): void;
}

// @public
export function readlineConnect(botContext: BotContext, commands: ReadonlyArray<Command>, readlineFactory?: typeof createInterface): Promise<ReadlineBot>;

// @public
export function removeCommandName(msg: string, command: Command, prefix: string): string;

// @public
export const ROLE_ADMIN_ONLY: Roles;

// @public
export interface Roles {
    admin: boolean;
    local: boolean;
    other: boolean;
}

// @public
export function sendWithRetry(client: RconClient, command: string, logger: Logger, retries?: number): Promise<string>;

// @public
export type StringsOnly<T> = T extends string ? T : never;

// (No @packageDocumentation comment for this package)

```
