import { Author, Message } from '../../bot/index.js';
import { removeCommandName } from '../../utils/command.js';
import { sendWithRetry } from '../../utils/rcon.js';
import { checkAuthor, ROLE_ADMIN_ONLY } from '../../utils/roles.js';
import { Command, CommandContext } from '../index.js';

/**
 * Run a SQL query on an RCON game server.
 *
 * This is a potentially dangerous command and limited to admins.
 */
export const rconSQL: Command = {
  name: 'rcon-sql',
  desc: 'SQL over rcon command',
  async auth(context: CommandContext, author: Author) {
    return checkAuthor(context.args.commandAdmins, ROLE_ADMIN_ONLY, author);
  },
  async run(context: CommandContext, message: Message) {
    const query = removeCommandName(message.content, rconSQL, context.args.commandPrefix);
    const result = await sendWithRetry(context.rcon, `sql ${query}`, context.logger);
    await message.reply(result);
  },
};
