import { codeBlock } from 'discord.js';

import { Message } from '../../bot/index.js';
import { sendWithRetry } from '../../utils/rcon.js';
import { Command, CommandContext } from '../index.js';

/**
 * List players who are currently online. Should work for any RCON game server.
 */
export const conanOnline: Command = {
  name: 'conan-online',
  desc: 'list players who are currently online',
  async run(context: CommandContext, message: Message) {
    const players = await sendWithRetry(context.rcon, 'listplayers', context.logger);
    await message.reply(`online players: ${codeBlock(players)}`);
  },
};
