import { codeBlock } from 'discord.js';

import { Message } from '../bot/index.js';
import { commandName } from '../utils/command.js';
import { Command, CommandContext } from './index.js';

/**
 * Reply with a summary of the available commands.
 *
 * @todo get the available commands from context rather than const
 */
export const help: Command = {
  name: 'help',
  desc: 'list the available commands',
  async run(context: CommandContext, message: Message) {
    const helps = context.commands.map((command) => {
      const name = commandName(command, context.args.commandPrefix);
      return `${name}: ${command.desc}`;
    });
    const body = codeBlock(helps.join('\n'));
    await message.reply(`commands: ${body}`);
  },
};
