import { Logger } from 'noicejs';

/**
 * Catch any errors from a promise and log them along with the given `message`.
 */
export function catchAndLog<ValueT>(p: Promise<ValueT>, logger: Logger, message: string): void {
  p.catch((err) => {
    logger.error(err, message);
  });
}
