import { expect } from 'chai';

import { parseArgs } from '../../src/args.js';
import { DataTable } from '../../src/data/index.js';
import { MemoryDataLayer } from '../../src/data/memory.js';
import { mockAuthor, REQUIRED_ARGS } from '../helpers.js';

describe('memory data layer', () => {
  // TODO: does this behavior actually make sense, considering data is persistent?
  it('should clear existing records when it reconnects');

  it('should store and fetch data', async () => {
    const data = new MemoryDataLayer(await parseArgs(REQUIRED_ARGS));

    await data.connect();

    const author = mockAuthor();
    const value = {
      value: Math.random().toString(),
    };
    await data.set(DataTable.STATE, author, 'test', value);

    const fetched = await data.get(DataTable.STATE, author, 'test');
    expect(fetched).to.deep.equal(value);
  });
});
