/* eslint-disable @typescript-eslint/no-magic-numbers */
import { expect } from 'chai';

import { parseTable } from '../../src/utils/table.js';

describe('table utils', () => {
  describe('parse table helper', () => {
    it('should parse lines into items', async () => {
      const input = [
        'a | b | c',
        '#1 a | b | c',
        '#2 d | e | f',
      ].join('\n');

      const table = parseTable(input);

      expect(table.length).to.equal(3);
      expect(table[1][0]).to.equal('a');
      expect(table[2][0]).to.equal('d');
    });

    it('should put lines in order', async () => {
      const input = [
        'a | b | c',
        '#2 d | e | f',
        '#1 a | b | c',
      ].join('\n');

      const table = parseTable(input);

      expect(table.length).to.equal(3);
      expect(table[1][0]).to.equal('a');
      expect(table[2][0]).to.equal('d');
    });
  });
});
